Index: main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowMenu.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowMenu.i18n.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowMenu.i18n.js	(revision 0)
@@ -0,0 +1,537 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.plugins.forms.workflow');
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu = function(id, configuration, pluginName) 
+{
+	org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.superclass.constructor.call(this, id, configuration, pluginName);
+};
+
+Ext.extend(org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu, org.ametys.ribbon.control.button.ActionButton, {});
+
+/**
+ * @private
+ * @property {Object} _lastParams The params received on the last refresh
+ */
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._lastParams;
+
+/**
+ * @private
+ * @property {String[]} _currentEntryIds The ids of the entries currently selected 
+ */
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._currentEntryIds;
+
+/**
+ * @private
+ * @propery {String} _worklowName the name of the workflow of this menu
+ */
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._workflowName;
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.createControl = function(size, colspan)
+{
+	var element = org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.superclass.createControl.call(this, size, colspan);
+	element._menuItems = [];
+	
+	org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._workflowName = this.getConfiguration()['workflow-name'];
+	
+	var menuCount = parseInt(this.getConfiguration()["menu-size"]); 
+	if (menuCount &gt; 0)
+	{
+		var items = [];
+		for (var i=0;  i &lt; menuCount; i++)
+		{
+			var actionId = this.getConfiguration()["menu-" + i];
+			element._menuItems[actionId] = new Ext.menu.Item ({
+				actionId: actionId,
+				text: this.getConfiguration()["menu-" + actionId + "-label"],
+				tooltip: this.getConfiguration()["menu-" + actionId + "-description"],
+				handler: eval(this.getConfiguration()["menu-" + actionId + "-action"]),
+				hasComment: this.getConfiguration()["menu-" + actionId + "-comment"] == 'true',
+				hasFurtherInfo: this.getConfiguration()["menu-" + actionId + "-further-information"] == 'true',
+				multiselectionEnabled: this.getConfiguration()["menu-" + actionId + "-enable-multiselection"] == 'true',
+				workflowActionPlugin: this.getConfiguration()["menu-" + actionId + "-actionPlugin"] || 'forms',
+				workflowActionUrl: this.getConfiguration()["menu-" + actionId + "-actionUrl"] || 'do-action',
+				ribbonControl: this
+			}); 
+			items.push(element._menuItems[actionId]);
+		}
+		
+		element.menu = new Ext.menu.Menu({
+			items: items
+		});
+	}
+	
+	return element;
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testTarget = function (target)
+{
+	return target.getType() == 'form-entry';
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testContentFormTarget = function (target)
+{
+	return target.getType() == 'content-form' &amp;&amp; target.getParameters().workflowName == org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._workflowName;
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.onMessage = function (messages)
+{
+	var alreadyRefreshed = false;
+	
+	// SELECTION
+	for (var i=messages.length - 1; i &gt;= 0; i--)
+	{
+		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
+		{
+			var targets = messages[i].getTargets();
+			var contentFormTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testContentFormTarget.createDelegate(this));
+			
+			if (contentFormTarget)
+			{
+				var allFormEntryTargetsObject = org.ametys.messagebus.message.MessageTargetHelper.findAll([contentFormTarget], org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testTarget.createDelegate(this))
+				var allFormEntryTargetsIds = this._convertToId(allFormEntryTargetsObject);
+			
+				// No content selected
+				if (allFormEntryTargetsIds.length == 0)
+				{
+					this.getElements().each(
+						function(element) 
+						{ 
+							element.setDisabled(true); 
+							element.toggle(false);
+						}
+					);
+					this._updateTip(this.getConfiguration()["noselection-description"]);
+					
+					this._currentEntryIds = [];
+				}
+				// A single target selected or multiselection is enabled
+				else if (allFormEntryTargetsIds.length == 1 || this.getConfiguration()["enable-multiselection"] == "true")
+				{
+					if (!this._areTheSame(this._currentEntryIds, allFormEntryTargetsIds))
+					{
+						this._currentEntryIds = allFormEntryTargetsIds;
+					
+						this._updateTip(this.getConfiguration()["refreshing-description"]);
+						
+						this.getElements().each(
+							function(element) 
+							{
+								element.refreshing();
+								element.setDisabled(true); 
+								element.toggle(false);
+							}
+						);
+						
+						org.ametys.ribbon.RibbonManager.getInstance().refreshElement('control', this, {formId: contentFormTarget.getParameters().id, entryIds: allFormEntryTargetsIds});
+					}
+				}
+				// Too many entries selected
+				else
+				{
+					this.getElements().each(function(element) { element.setDisabled(true); });
+					this._updateTip(this.getConfiguration()["multiselection-disabled-description"]);
+					
+					this._currentEntryIds = [];
+				}
+				
+				return;
+			}
+		}
+	}
+	
+	// WORKFLOW
+	for (var i=0; i &lt; messages.length; i++)
+	{
+		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGED
+			|| messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGING)
+		{
+			var targets = messages[i].getTargets();
+			var contentFormTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testContentFormTarget.createDelegate(this));
+			
+			if (contentFormTarget)
+			{
+				var allFormEntryTargetsObject = org.ametys.messagebus.message.MessageTargetHelper.findAll([contentFormTarget], org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testTarget.createDelegate(this))
+				var allFormEntryTargetsIds = this._convertToId(allFormEntryTargetsObject);
+				
+				var currentSelection = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
+				
+				for (var t=0; currentSelection != null &amp;&amp; t &lt; allFormEntryTargetsIds.length; t++)
+				{
+					var currentSelectionIds = this._convertToId(org.ametys.messagebus.message.MessageTargetHelper.findAll(currentSelection, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testTarget.createDelegate(this) ));
+					
+					for (var c=0; c &lt; currentSelectionIds.length; c++)
+					{
+						if (currentSelectionIds[c] == allFormEntryTargetsIds[t])
+						{
+							this._updateTip(this.getConfiguration()["refreshing-description"]);
+							
+							this.getElements().each(
+								function(element) 
+								{ 
+									element.setDisabled(true); 
+									element.toggle(false);
+									element.refreshing();
+								}
+							);
+							
+							if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGED)
+							{
+								if (alreadyRefreshed == false)
+								{
+									alreadyRefreshed = true;
+									var formEntryTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testTarget.createDelegate(this));
+									org.ametys.ribbon.RibbonManager.getInstance().refreshElement('control', this, {formId: contentFormTarget.getParameters().id, entryIds: currentSelectionIds});
+								}
+							}
+							
+							return;
+						}
+					}
+				}
+			}
+		}
+	}
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._updateTip = function(tooltip)
+{
+	var begin = this.getConfiguration()["default-description"];
+	if (begin == null)
+	{
+		begin = "";
+	}
+	if (tooltip == null)
+	{
+		tooltip = "";
+	}
+	
+	var finalTooltip = begin + ((begin != "" &amp;&amp; tooltip != "") ? "&lt;br/&gt;&lt;br/&gt;" : "") + tooltip
+	
+	this.updateTooltip(finalTooltip, context.contextPath + this.getConfiguration()['icon-medium']);
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.configurationError = function(response)
+{
+	this.getElements().each(
+		function(element) 
+		{ 
+			element.setDisabled(true); 
+			element.stopRefreshing();
+		}
+	);
+	this._updateTip(this.getConfiguration()["noselection-description"]);
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._areTheSame = function (tab1, tab2)
+{
+	if (tab1 == tab2)
+	{
+		return true;
+	}
+
+	if (tab1 == null || tab2 == null || tab1.length != tab2.length)
+	{
+		return false;
+	}	
+	
+	for (var i=0; i &lt; tab1.length; i++)
+	{
+		if (tab2.indexOf(tab1[i]) == -1)
+		{
+			return false;
+		}
+	}
+	
+	return true;
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype._convertToId = function (targets)
+{
+	var targetsIds = [];
+	for (var i = 0; i &lt; targets.length; i++)
+	{
+		targetsIds.push(targets[i].getParameters()['id']);
+	}
+	return targetsIds;
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.configurationChanged = function(params)
+{
+	this.getElements().each(function(element){element.stopRefreshing();});
+	
+	this._lastParams = params;
+	
+	var count = parseInt(params["entry-count"]);
+	var tooltip = "";
+	
+	// Action map. Key is action id, Value is an array of content name
+	var menuCount = parseInt(this.getConfiguration()["menu-size"]); 
+	var action = {};
+	for (var i=0;  i &lt; menuCount; i++)
+	{
+		var actionId = this.getConfiguration()["menu-" + i];
+		action[actionId] = [];
+	}
+	
+	var hasActionEnabled = false;
+	var noMatchingEntries = false;
+	
+	if (count &gt; 0)
+	{
+		tooltip += count + ' ' + this.getConfiguration()["entryselected-description"];
+
+		for (var i=0; i &lt; count; i++)
+		{
+			// loop on action for this entry
+			if (menuCount &gt; 0)
+			{
+				for (var actionId in action)
+				{
+					var canDoAction = "true" == params["entry-" + i + "-action-" + actionId];
+					if (canDoAction)
+					{
+						action[actionId].push(params["entry-" + i + "-id"])
+					}
+				}
+			}
+		}
+		
+		for (var actionId in action)
+		{
+			this.getElements().each(
+				function(element) 
+				{
+					var menuItem = element._menuItems[actionId]; 
+					
+					var disable = count &gt; 1 &amp;&amp; !menuItem.multiselectionEnabled;
+					menuItem.setDisabled(disable || action[actionId].length == 0);
+					menuItem.entryIds = action[actionId];
+					hasActionEnabled = hasActionEnabled || action[actionId].length != 0;
+				}
+			);
+		}
+
+		if (!hasActionEnabled)
+		{
+			tooltip += '&lt;br/&gt;&lt;br/&gt;';
+			tooltip += this.getConfiguration()["noaction-available-description"];
+		}
+		
+	}
+	else
+	{
+		tooltip = this.getConfiguration()["nomatch-description"];
+		noMatchingEntries = true;
+	}
+	
+	this._updateTip(tooltip);
+	this.getElements().each(
+		function(element) 
+		{ 
+			element.allowDepress = false;
+			element.toggle(count &gt; 0);
+			element.setDisabled((!hasActionEnabled &amp;&amp; menuCount &gt; 0) || noMatchingEntries); 
+		}
+	);
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.act = function()
+{
+	// nothing
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.menuAct = function(item, event)
+{
+    if (item &amp;&amp; item.hasComment)
+    {
+		// Show the comment dialog box to the user 
+		org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.showCommentBox(item);
+    }
+    else
+    {
+    	// Direct call to the workflow action, without comment.
+    	org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct(item, '');
+    }
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct = function(item, comment)
+{
+    var params = item.ribbonControl._lastParams;
+    var currentSelection = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
+    var formTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(currentSelection, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._testContentFormTarget);
+    var formId = formTarget.getParameters().id;
+    
+	if (item &amp;&amp; item.hasFurtherInfo)
+	{
+	    // Show the further information dialog box to the user 
+		org.ametys.plugins.forms.workflow.FurtherInformationDialog(formId, item, comment, org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct2);
+	}
+	else
+	{
+		org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct2(formId, item, comment);
+	}
+	
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct2 = function(formId, item, comment, furtherInfo)
+{
+	var target = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
+			'id': formId, 
+			'workflowName': org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._workflowName
+	});
+	
+	var  entryIds = item.entryIds;
+	for (var i=0; i &lt; entryIds.length; i++)
+	{
+		target.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': entryIds[i]}));
+    }
+	
+	
+	var plugin = item.workflowActionPlugin;
+	var url = item.workflowActionUrl + '/' + item.actionId;
+	
+	org.ametys.servercomm.ServerComm.getInstance().suspend();
+	
+	for (var i=0; i &lt; entryIds.length; i++)
+	{
+		var params = {};
+		params.comment = comment;
+		params.formId = formId;
+		params.furtherInfo = Ext.util.JSON.encode(furtherInfo);
+		params.entryId = entryIds[i];
+		
+		var serverMessage = new org.ametys.servercomm.ServerMessage(plugin, url, params, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, item.ribbonControl.workflowActionCallback, item.ribbonControl, {entryId: entryIds[i], max: entryIds.length, formId: formId});
+		org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
+	}
+	org.ametys.servercomm.ServerComm.getInstance().restart();
+	
+	var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGING, null, [target]);
+	org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.cumulate = 0;
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.cumulatedIds = [];
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.prototype.workflowActionCallback = function(response, args)
+{
+	this.cumulatedIds.push(args.entryId);
+
+	if (org.ametys.servercomm.ServerComm.handleBadResponse("<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_ERROR_DESC'/>", response, "org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu"))
+	{
+		// we have to continue regardless of the result, because we have to rollback the workflowchanging state
+	}
+
+	this.cumulate++;
+	
+	if (this.cumulate == args.max)
+	{
+		var target = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
+				'id': args.formId, 
+				'workflowName': org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu._workflowName
+		});
+		
+		// Send the event for all contents so discard the next callback
+		if (this.cumulatedIds.length &gt; 0)
+		{
+			for (var i = 0; i &lt; this.cumulatedIds.length; i++)
+			{
+				target.getSubTargets().push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': this.cumulatedIds[i]}));
+			}
+	    }
+			
+		var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_WORKFLOWCHANGED, null, [target]);
+		org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
+		
+		this.cumulatedIds = [];
+		this.cumulate = 0;
+	}
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.showCommentBox = function(item)
+{
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.item = item;
+    
+    if (org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentDialog == null)
+    {
+        org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentForm = new Ext.form.FormPanel({
+            region: 'center',
+            border: false,
+            autoScroll: true,
+            
+            defaultType: 'textfield',
+            items: [
+                new org.ametys.HtmlContainer({
+                    cls: 'workflow-comment-dialog-help',
+                    html: "&lt;p&gt;<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_COMMENTS_DIALOG_MESSAGE'/>&lt;/p&gt;"
+                }),
+                new org.ametys.form.TextAreaField({
+                    name: 'comment',
+                    desc: "<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_COMMENTS_DIALOG_TEXTAREA_DESC'/>",
+                    width: 360,
+                    height: 140
+                })
+            ],
+            
+            labelWidth: 5,
+            html: ''
+        });
+        
+        var id = Ext.id();
+        org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentDialog = new org.ametys.DialogBox({
+            layout: 'fit',
+            
+            title: "<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_COMMENTS_DIALOG_TITLE'/>",
+            icon: getPluginResourcesUrl('forms') + '/img/form-entry_16.png',
+            cls: 'workflow-comment-dialog',
+            
+            width: 450,
+            height: 250,
+            autoScroll: false,
+            
+            items: [ org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentForm ],
+            
+            defaultButton: id,
+            closeAction: 'hide',
+            buttonAlign: 'center',
+            buttons : [{
+                text: "<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_COMMENTS_DIALOG_OK'/>",
+                handler: org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentCallback,
+                id: id
+            },{
+                text: "<i18n:text i18n:key='PLUGINS_FORMS_WORKFLOW_COMMENTS_DIALOG_CANCEL'/>",
+                handler: org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentCancel
+            }]
+        });
+    }
+    
+    // Empty the comment textarea.
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentForm.getForm().findField('comment').setValue('');
+    
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentDialog.show();
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentCallback = function(button, event)
+{
+    var values = org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentForm.getForm().getValues();
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentDialog.hide();
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.doMenuAct(org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.item, values.comment);
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentCancel = function(button, event)
+{
+    org.ametys.plugins.forms.workflow.FormEntriesWorkflowMenu.commentDialog.hide();
+}
Index: main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowTab.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowTab.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/workflow/FormEntriesWorkflowTab.js	(revision 0)
@@ -0,0 +1,73 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.plugins.forms.workflow');
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab = function(id, configuration, pluginName, tabPanel) 
+{
+	org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab.superclass.constructor.call(this, id, configuration, pluginName, tabPanel);
+	
+	if (configuration['workflow-name'] != null)
+	{
+	    this._workflowNameRegexp = new RegExp(configuration['workflow-name']);
+	}
+}
+
+Ext.extend(org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab, org.ametys.cms.ribbon.tab.SelectionTab, {});
+
+/**
+ * @private
+ * @property {RegExp} _workflowNameRegexp The workflow name regular expression to match
+ */
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab.prototype._workflowNameRegexp;
+
+/**
+ * @private
+ * Test a target. Does it match ?
+ * @return {org.ametys.messagebus.message.MessageTarget} The target to check
+ */
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab.prototype._testTarget = function(target)
+{
+	var matchSelection = org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab.superclass._testTarget.call(this, target);
+	if (!matchSelection)
+	{
+		return false;
+	}
+	
+	var contentFormTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst([target], this._testContentFormTarget.createDelegate(this));
+	if (contentFormTarget)
+	{
+		var workflowName = contentFormTarget.getParameters().workflowName;
+		if (this._workflowNameRegexp != null && !this._workflowNameRegexp.test(workflowName))
+		{
+			// Wrong tab
+			return false;
+		}
+		
+		if (this._workflowNameRegexp == null && workflowName)
+		{
+			// Do not display the tab with no workflow in that case
+			return false;
+		}
+	}
+	
+	return true;
+}
+
+org.ametys.plugins.forms.workflow.FormEntriesWorkflowTab.prototype._testContentFormTarget = function(target)
+{
+	return target.getType() == 'content-form';
+}
\ No newline at end of file
Index: main/plugin-forms/resources/js/org/ametys/forms/workflow/FormWorkflowButton.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/workflow/FormWorkflowButton.i18n.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/workflow/FormWorkflowButton.i18n.js	(revision 0)
@@ -0,0 +1,82 @@
+/*org.ametys.plugins.forms.workflow
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.plugins.forms.workflow');
+
+/**
+ * This widget list the available workflows for a form.
+ */
+org.ametys.plugins.forms.workflow.FormWorkflowButton = function(id, configuration, pluginName)
+{
+	org.ametys.plugins.forms.workflow.FormWorkflowButton.superclass.constructor.call(this, id, configuration, pluginName);
+}
+
+Ext.extend(org.ametys.plugins.forms.workflow.FormWorkflowButton, org.ametys.cms.control.ComboBoxField, {});
+
+org.ametys.plugins.forms.workflow.FormWorkflowButton._applyWorkflow = function (combo, record, index)
+{
+	var newValue = record.data.id;
+	if (org.ametys.plugins.forms.workflow.FormWorkflowButton._currentValue != newValue)
+	{
+		Ext.Msg.confirm(
+				"<i18n:text i18n:key="PLUGINS_FORMS_FORMS_EDITOR_WORKFLOW_CHANGE_DIALOG_TITLE"/>", 
+				"<i18n:text i18n:key="PLUGINS_FORMS_FORMS_EDITOR_WORKFLOW_CHANGE_DIALOG_TEXT"/>", 
+				function (answer) {
+					if (answer != 'yes')
+					{
+						combo.setValue(org.ametys.plugins.forms.workflow.FormWorkflowButton._currentValue);
+					}
+					else
+					{
+						org.ametys.plugins.forms.workflow.FormWorkflowButton._currentNode.setAttribute("form_workflow", newValue);
+						org.ametys.plugins.forms.workflow.FormWorkflowButton._currentValue = newValue;
+					}
+				}, 
+				this
+		);
+	}
+}
+
+org.ametys.plugins.forms.workflow.FormWorkflowListener = function(ribbonCombo, target, node)
+{
+	var off = target == null || node == null;
+	if (off)
+	{
+		ribbonCombo.getElements().each(function(combo) {combo.setDisabled(true);});
+		return;
+	}
+	
+	var formNode = org.ametys.forms._getForm(node);
+	if (formNode != null)
+	{
+		org.ametys.plugins.forms.workflow.FormWorkflowButton._currentNode = formNode;
+	
+		ribbonCombo.getElements().each(
+			function(combo) 
+			{
+				combo.setDisabled(false);
+	
+				var formWorkflow = formNode.getAttribute("form_workflow");
+				var value = formWorkflow != null ? formWorkflow : combo.getStore().getRange()[0].data.id;
+				formNode.setAttribute("form_workflow", value);
+				
+				combo.setValue(value);
+	
+				org.ametys.plugins.forms.workflow.FormWorkflowButton._currentValue = value;
+			}
+		);
+	}
+}
